//PER_PIXEL material/lighting VERTEX

varying vec3 vertex_light_position;
varying vec3 vertex_light_half_vector;
varying vec3 vertex_normal;

void main() 
{            
    // Calculate the normal value for this vertex, in world coordinates (multiply by gl_NormalMatrix)
    vertex_normal = normalize(gl_NormalMatrix * gl_Normal);
    
    // Calculate the light position for this vertex
    vertex_light_position = normalize(gl_LightSource[0].position.xyz);
    
   // Calculate the light’s half vector
   // vertex_light_half_vector = normalize(gl_LightSource[0].halfVector.xyz);
   //    vertex_light_half_vector = vec3(0.5, 0.5, 0.5); //normalize(gl_LightSource[0].halfVector.xyz);
   
   vec3 ecPos = vec3(gl_ModelViewMatrix * gl_Vertex);
   vec3 lightVec = normalize(vertex_light_position - ecPos); 
   vertex_light_half_vector = reflect(-lightVec, vertex_normal); 
   //vertex_light_half_vector = vec3(0.5, 0.5, 0.5); //reflect(-lightVec, vertex_normal); 

    // Set the front color to the color passed through with glColorf
    //gl_FrontColor = gl_Color;
    
    // Set the position of the current vertex 
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
}

